# A Ruby script to demostrate the output of the 'Ycon' utility.
# Run it from a Terminal with 'ruby testycon.rb' or use it within 'irb'
# via 'load "testycon.rb"'.  (Ycon must be in your path, of course.)

# When it runs, a 'Ycon' window should appear at top left; drag any
# icon, or other droppable object onto the window, and it will print out
# an Array structure with the contents of the drop-message in processable form.
# (Or you can copy something to the clipboard and paste it into the window.)


pp = IO.popen("Ycon -d")	# start Ycon and read from it via pipe
# (Note that the '-d' option means that long binary items will get printed
# in their entirety.  If you would prefer short form, remove the option.)

	mstr = 1		# start loop with an arbitrary non-string
	until mstr == ""	# empty string returned when Ycon is closed
		mstr = ""
		pp.each{|s| mstr<<s		# accumulate all the lines from one message
			break if s == "]\n"	# the final line always looks like this
		}
		p eval(mstr)		# convert the string into an Array and print it
	end
